/*
 * SearchResultDocument.java
 *
 * Created on 21 May 2003, 16:23
 */

package at.ac.tuwien.infosys.rnue.implementation.http;

import at.ac.tuwien.infosys.rnue.interfaces.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author  therapy
 */
public class SearchResultDocument implements at.ac.tuwien.infosys.rnue.interfaces.IDocument {
    
    String content = "<html><head><title>Search Results</title></head><body><h1>Results</h1>";
    
    /** Creates a new instance of SearchResultDocument */
    public SearchResultDocument(ISearchResult sr) {
        Enumeration own = sr.owners();
        while(own.hasMoreElements())
        {
            String owner = (String)own.nextElement();
            content += "<h2>" + owner + ":</h2><ul>";
            IFileList ifl = sr.getFileList(owner);
            Enumeration files = ifl.files();
            while(files.hasMoreElements())
            {
                IFile file = (IFile)files.nextElement();
                content += "<li><a href=\"" + ifl.getDownloadURLPrefix() + file.getFilePathAndName() + "\">" +  file.getFilePathAndName() + "</a><br>";
            }
            content += "</ul>";
        }
        content += "</body></html>";
    }
    
    public String getCachingInfo() {
        return null;
    }
    
    public java.io.InputStream getContent() {
        try {
            return new ByteArrayInputStream(content.getBytes("UTF-8"));
        } catch(java.io.UnsupportedEncodingException e)
        { e.printStackTrace();
        }
        return null;
    }
    
    public long getContentLength() {
        return content.length();
    }
    
    public String getContentType() {
        return "text/html";
    }
    
    public java.util.Date getLastModified() {
        return new Date();
    }
    
}
