/*
 * ShareMeEntry.java
 *
 * Created on 21 May 2003, 15:57
 */

package at.ac.tuwien.infosys.rnue.implementation.http;

/**
 *
 * @author  therapy
 */

import at.ac.tuwien.infosys.rnue.interfaces.*;
import at.ac.tuwien.infosys.rnue.helpers.http.*;
import java.util.*;

public class ShareMeEntry implements at.ac.tuwien.infosys.rnue.interfaces.IHTTPServerEntry {
    
    IShareMe sm;
    
    /** Creates a new instance of ShareMeEntry */
    public ShareMeEntry(IShareMe sm) {
        this.sm = sm;
    }
    
    public String getDescription() {
    return "ShareMe Search Helper";
    }
    
    public at.ac.tuwien.infosys.rnue.interfaces.IDocument getDocument(String str) throws at.ac.tuwien.infosys.rnue.helpers.HTTPException, at.ac.tuwien.infosys.rnue.helpers.ShareMeException {
        if(!str.startsWith(IConstants.SHAREME_CGI + "?"))
            return new SimpleDocument("wrong prefix",false);
        String kvpairs = str.substring(IConstants.SHAREME_CGI.length() + 1, str.length());
        StringTokenizer kvp = new StringTokenizer(kvpairs,"&");
        String searchstring = null;
        while(kvp.hasMoreTokens())
        {
            String kv = kvp.nextToken();
            if(kv.indexOf('=') == -1) continue;
            String k = kv.substring(0,kv.indexOf('='));
            String v = kv.substring(kv.indexOf('=')+1,kv.length());
            if(k.equals(IConstants.SHAREME_PARAMNAME)) 
            {
                searchstring = v;
                break;
            }
        }
        if(searchstring == null) return new SimpleDocument("search parameter missing",false);
        return new SearchResultDocument(sm.search(searchstring));
    }
}
