/*
 * HostListImpl.java
 *
 * Created on 14 March 2003, 10:19
 */

package at.ac.tuwien.infosys.rnue.implementation.multicast;

/**
 *
 * @author  therapy
 */
public class HostListImpl implements at.ac.tuwien.infosys.rnue.interfaces.IHostList {
    
    private java.util.Hashtable ht = new java.util.Hashtable();

    private HostListImpl.GarbageCollector gc;
    
    private class GarbageCollector implements Runnable {

        private boolean running = false;
        
        /** When an object implementing interface <code>Runnable</code> is used
         * to create a thread, starting the thread causes the object's
         * <code>run</code> method to be called in that separately executing
         * thread.
         * <p>
         * The general contract of the method <code>run</code> is that it may
         * take any action whatsoever.
         *
         * @see     java.lang.Thread#run()
         *
         */
        public void run() {
            running = true;
            while(running)
            {
                synchronized(ht)
                {
                    java.util.Enumeration enum = ht.elements();
                    while(enum.hasMoreElements())
                    {
                        at.ac.tuwien.infosys.rnue.interfaces.IHostInfo ih = 
                        (at.ac.tuwien.infosys.rnue.interfaces.IHostInfo)enum.nextElement();
                        if(System.currentTimeMillis() - ih.getTimestamp() > 
                            at.ac.tuwien.infosys.rnue.interfaces.IConstants.LIFETIME_OF_HOSTINFOS)
                        {
                            ht.remove(constructKey(ih));
//                            System.out.println("GarbageCollector DEAD : " + ih.getHostInfoMessage().getServiceName());
                        }
//                        else
//                            System.out.println("GarbageCollector ALIVE: " + ih.getHostInfoMessage().getServiceName());
                    }
                }
                synchronized(this) {
                    try {
                    ((java.lang.Object)this).wait(at.ac.tuwien.infosys.rnue.interfaces.IConstants.GC_INTERVAL);
                    } catch (InterruptedException ie) {
                    // do nothing; this was on purpose, i.e., we waited long enough
                    }
                }
            }
        }
        public void stop()
        {
            running = false;
            synchronized(this) {
                this.notify();
            }
        }
    }
    
    /** Creates a new instance of HostListImpl */
    public HostListImpl() {
        gc = new HostListImpl.GarbageCollector();
        new Thread(gc).start();
    }
    
    public boolean contains(at.ac.tuwien.infosys.rnue.interfaces.IHostInfo iHostInfo) {
        return ht.containsKey(constructKey(iHostInfo));
    }
    
    public java.util.Enumeration elements() {
        return ht.elements();
    }
    
    public at.ac.tuwien.infosys.rnue.interfaces.IHostInfo get(String str) {
        return (at.ac.tuwien.infosys.rnue.interfaces.IHostInfo)ht.get(str);
    }
    
    public java.util.Enumeration keys() {
        return ht.keys();
    }
    
    public at.ac.tuwien.infosys.rnue.interfaces.IHostInfo put(at.ac.tuwien.infosys.rnue.interfaces.IHostInfo iHostInfo) {
        return (at.ac.tuwien.infosys.rnue.interfaces.IHostInfo)
                ht.put(constructKey(iHostInfo),iHostInfo);
    }
    
    public at.ac.tuwien.infosys.rnue.interfaces.IHostInfo remove(String str) {
        return (at.ac.tuwien.infosys.rnue.interfaces.IHostInfo)ht.remove(str);
    }
    
    public void stopGarbageCollector() {
        gc.stop();
    }

    private static String constructKey(at.ac.tuwien.infosys.rnue.interfaces.IHostInfo iHostInfo)
    {
        return(iHostInfo.getHostInfoMessage().getRegistryHost() + ":" +
                        iHostInfo.getHostInfoMessage().getRegistryPort());
    }
    
    /*
    public static void main(String[] arg)
    {
        HostListImpl hl = new HostListImpl();
        IHostInfo ih = new HostInfoImpl();
        IHostInfoMessage ihm = new HostInfoMessageImpl();
        ihm.setRegistryHost("master");
        ihm.setRegistryPort(4711);

        ih.setTimestamp(System.currentTimeMillis());
        ih.setHostInfoMessage(ihm);
        hl.put(ih);
        java.util.Enumeration k = hl.keys();
        hl.put(ih);
     }
        */
}
