/*
 * IsAliveSender.java
 *
 * Created on 14 March 2003, 11:10
 */

package at.ac.tuwien.infosys.rnue.implementation.multicast;

/**
 *
 * @author  therapy
 */

import java.io.ByteArrayOutputStream; 
import java.io.ObjectOutputStream; 
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.util.Properties;
import at.ac.tuwien.infosys.rnue.helpers.ShareMeException;
import at.ac.tuwien.infosys.rnue.helpers.multicast.HostInfoMessageImpl;
import at.ac.tuwien.infosys.rnue.interfaces.IConstants;
import at.ac.tuwien.infosys.rnue.interfaces.IHostInfoMessage;
import at.ac.tuwien.infosys.rnue.interfaces.IIsAliveSender;

public class IsAliveSender extends java.util.TimerTask implements at.ac.tuwien.infosys.rnue.interfaces.IIsAliveSender {
    
    DatagramPacket dp;
    MulticastSocket mcastsocket;
    
    /** Creates a new instance of IsAliveSender */
    public IsAliveSender(Properties props) throws ShareMeException {
        try {
            mcastsocket = new MulticastSocket(Integer.parseInt(props.getProperty(IConstants.MULTICAST_PORT)));
            IHostInfoMessage imsg = new HostInfoMessageImpl();
            imsg.setHumanReadableName(props.getProperty(IConstants.HUMAN_READABLE_NAME));
            imsg.setRegistryHost(props.getProperty(IConstants.RMI_REGISTRY_HOST));
            imsg.setRegistryPort(Integer.parseInt(props.getProperty(IConstants.RMI_REGISTRY_PORT)));
            imsg.setServiceName(props.getProperty(IConstants.RMI_SERVICE_NAME));
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            new ObjectOutputStream(baos).writeObject(imsg);
            byte[] bar = baos.toByteArray();
            dp = new DatagramPacket(bar,bar.length);
            dp.setPort(Integer.parseInt(props.getProperty(IConstants.MULTICAST_PORT)));
            dp.setAddress(InetAddress.getByName(props.getProperty(IConstants.MULTICAST_ADDRESS)));

        } catch(java.io.IOException e) {        // FIXME
            throw new ShareMeException("Can't create IsAliveSender");
        }
    }
    
    /** When an object implementing interface <code>Runnable</code> is used
     * to create a thread, starting the thread causes the object's
     * <code>run</code> method to be called in that separately executing
     * thread.
     * <p>
     * The general contract of the method <code>run</code> is that it may
     * take any action whatsoever.
     *
     * @see     java.lang.Thread#run()
     *
     */
    public void run() {
        try {
            mcastsocket.send(dp);
        } catch(java.io.IOException e) {        
            e.printStackTrace();
        }
    }
    public void stop()
    {
        this.cancel();
    }
}
