/*
 * ShutdownListener.java
 *
 * Created on 13 March 2003, 21:50
 */

package at.ac.tuwien.infosys.rnue.implementation.multicast;

/**
 *
 * @author  therapy
 */

import java.net.DatagramSocket;
import java.net.DatagramPacket;
import at.ac.tuwien.infosys.rnue.helpers.ShareMeException;
import at.ac.tuwien.infosys.rnue.interfaces.IConstants;
import at.ac.tuwien.infosys.rnue.interfaces.IShareMe;

public class ShutdownListener implements java.lang.Runnable {
    
    IShareMe is;
    int port;
    String matchstring;
    
    /** Creates a new instance of ShutdownListener */
    public ShutdownListener(IShareMe is, int port, String pwd) {
        this.is = is;
        this.port = port;
        this.matchstring = IConstants.EXIT_FLAG + " " + pwd;
    }
    
    /** When an object implementing interface <code>Runnable</code> is used
     * to create a thread, starting the thread causes the object's
     * <code>run</code> method to be called in that separately executing
     * thread.
     * <p>
     * The general contract of the method <code>run</code> is that it may
     * take any action whatsoever.
     *
     * @see     java.lang.Thread#run()
     *
     */
    public void run() {
        try {
            byte[] buf = new byte[IConstants.MAX_UDP_PACKET_LENGTH];
            DatagramSocket ds = new DatagramSocket(port);
            DatagramPacket dp = new DatagramPacket(buf,IConstants.MAX_UDP_PACKET_LENGTH);
            String trystring = "";
            do 
            {
                try {
                    ds.receive(dp);
                    trystring = new String(dp.getData(),dp.getOffset(),dp.getLength());
                } catch(java.io.IOException e) {     // ignore
                }
            } while(!matchstring.equals(trystring));
        } catch(java.net.SocketException e) {        // (try to) terminate thread
            System.err.println("Socket Exception: " + e.getMessage());
        }
        try {
            is.stop();
        } catch(ShareMeException e) {
            e.printStackTrace();                    // termination failed
        }
    }
}
