/*
 * SearchEngineImpl.java
 *
 * Created on 27 April 2003, 15:07
 */

package at.ac.tuwien.infosys.rnue.implementation.search;

import at.ac.tuwien.infosys.rnue.helpers.search.*;
import at.ac.tuwien.infosys.rnue.helpers.*;
import java.util.*;
import at.ac.tuwien.infosys.rnue.interfaces.*;
import java.security.*;

/**
 *
 * @author  therapy
 */
public class SearchEngineImpl extends java.rmi.server.UnicastRemoteObject 
implements at.ac.tuwien.infosys.rnue.interfaces.ISearchEngine {
    
   
    FileSystemHelperImpl fs;
    String dlurl;
    ISecurityHelper isc;
    
    /** Creates a new instance of SearchEngineImpl */
    public SearchEngineImpl(String filebase, String dlurl, ISecurityHelper isc) throws java.rmi.RemoteException {
        this.isc = isc;
        this.dlurl = dlurl;
        try {
            fs = new FileSystemHelperImpl(filebase);        
            
        } catch(Exception e)
        { e.printStackTrace();
        }
    }
    
    public at.ac.tuwien.infosys.rnue.interfaces.ISearchResponse search(at.ac.tuwien.infosys.rnue.interfaces.ISearchRequest iSearchRequest) throws at.ac.tuwien.infosys.rnue.helpers.ShareMeException, java.rmi.RemoteException {
        SearchResponseImpl sri;

        if(iSearchRequest == null)
            throw new ShareMeException("Your iSearchRequest object is null.");
        if(iSearchRequest.getSearchString() == null)
            throw new ShareMeException("Your iSearchRequest.getSearchString() object is null.");
        if(iSearchRequest.getRequestOriginator() == null)
            throw new ShareMeException("Your iSearchRequest.getRequestOriginator() object is null.");

        if(iSearchRequest.getSignature() != null)
        {
             if(!isc.verify(iSearchRequest.getSearchString(),
                        iSearchRequest.getSignature(), 
                        isc.getPublicKeyFromCA(iSearchRequest.getRequestOriginator())))
             throw new ShareMeException("Invalid signature for " + iSearchRequest.getRequestOriginator());
        }
        FileListImpl fl = new FileListImpl(dlurl, fs.searchFor(iSearchRequest.getSearchString()));
        if(iSearchRequest.getSignature() != null)
            sri = new SearchResponseImpl(fl,isc.sign(fl));
        else
            sri = new SearchResponseImpl(fl,null);
        return sri;
    }
    
}
